
\chapter{Examples, howtos, and Use Cases}
This section can be viewed as a set of tutorials, and howtos.


\section{Use Case 1 : I want to deploy just one peer}
This example is intended to people who wants to experiment right now. 
We will explain several things in this tutorial:
\begin{itemize}
	\item Launch Somewhere
	\item Use command line parameters
	\item Use the Console
	\item Register a local Knowledge base, with Somewhere instance files
	\item Perform a query on the local Knowledge base
\end{itemize}




\subsection{How to launch Somewhere ?}
Launching Somewhere is as easy as :
\begin{lstlisting}[language=sh]
	java -jar Somewhere.jar
\end{lstlisting}
Somewhere doesn't need any specific external dependancies, but a JVM 1.6 is needed.

If you want to compile somewhere from the svn source directory, just enter these commands :
\begin{lstlisting}[language=sh]
	cd Somewhere
	rake compile
\end{lstlisting}

After the compile (if successfull, which should be the case), you can directly execute the
somewhere jar contained in the \verb!swr.cli/target/! directory or, simply enter :
\begin{lstlisting}[language=sh]
	cd swr.cli/target; java -jar swr.cli-*.one-jar.jar &
\end{lstlisting}


\subsection{How to use the Console ?}
Somewhere 2.0 includes a console shell user interface, that you can launch using the 
command :
\begin{lstlisting}[language=sh]
	java -jar Somewhere.jar --console
\end{lstlisting}
Or, if you want to use Somewhere from the svn source directory, use (after compilation) :
\begin{lstlisting}[language=sh]
	rake cli
\end{lstlisting}

From the console shell, you can enter commands, like a regular shell. \\
You can use the \verb!help! command to print a list of known commands.


\subsection{How to register a local Knowledge Base ?}
To register a new propositional instance for this peer, use the command (in
the shell) :
\begin{lstlisting}
	15H 34M 50S $ loadNewPropositionalInstance PATH
\end{lstlisting}
where \verb!PATH! is the path for the file to load. \\
For the current implementation of Somewhere, two instances file format are supported:
XML (from SomewherePlusJXTA), and SWR (from Somewhere-Adjiman). The loader
detects the correct file format based on the extension of the file. \\
Alternatively, you can also specify a directory in \verb!PATH! : the loader
will load the correct file from this directory, based on the name of the local peer
(which, without proper configuration file, is the hostname of the computer). \\
When you register an instance file, it will replace the old instance, if there was
one already loaded. \\
TODO :add an example file to add


\subsection{How to Perform a query on the Knowledge base ?}
To perform a query on the knowledge base, use the command :
\begin{lstlisting}
	15H 34M 54S $ query QUERY
\end{lstlisting}
Where \verb!QUERY! is the query to do. \\
TODO : Add stuff on query syntax !
TODO : Add a sample query





\section{Use Case 2 : I want to deploy several peers}
We will explain several things in this tutorial:
\begin{itemize}
%	\item Make advanced Somewhere configuration files
%	\item Use the Console - Advanced level
	\item Register several Knowledge bases on several peers
	\item Know if all known peers are accessibles
	\item Perform a query on the network
\end{itemize}

\subsection{How to register instances on several peers ?}
TODO %TODO

\subsection{How to know if all known peers are accessibles ?}
TODO %TODO

\subsection{How to perform a query on the group of peers ?}
TODO %TODO


\section{Use Case 3 : I want to use JXTA's Relay and Rendez-vous peers}
TODO


